=== debian/changelog ===
mongo-cxx-driver (4.0.0-1) experimental; urgency=medium

  * New upstream release
  * Drop Kyle Kloberdanz as uploader
  * Bump dependency on libmongoc-dev
  * Drop MNMLSTC build profile and Boost dependency

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 26 Nov 2024 12:36:16 -0500

mongo-cxx-driver (3.11.0-1) experimental; urgency=medium

  * New upstream release
  * d/rules: set -DENABLE_TESTS=OFF (since upstream CI is very thorough)
  * d/copyright: remove references to removed files

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 02 Oct 2024 17:21:34 -0400

mongo-cxx-driver (3.10.2-1) experimental; urgency=medium

  * New upstream release
  * Bump dependency on libmongoc-dev
  * Update to Standards-Version 4.7.0 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 27 Jun 2024 14:33:50 -0400

mongo-cxx-driver (3.10.1-1) experimental; urgency=medium

  * New upstream release

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Wed, 13 Mar 2024 17:01:46 -0500

mongo-cxx-driver (3.9.0-1) experimental; urgency=medium

  * New upstream release

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Wed, 08 Nov 2023 15:27:55 -0600

mongo-cxx-driver (3.8.1-1) experimental; urgency=medium

  * New upstream release

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Fri, 06 Oct 2023 19:32:54 +0000

mongo-cxx-driver (3.8.0-1) experimental; urgency=medium

  * New upstream release
  * Bump dependency on libmongoc-dev

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Mon, 26 Jun 2023 13:56:18 +0000

mongo-cxx-driver (3.7.1-1) experimental; urgency=medium

  * New upstream release
  * Update to Standards-Version 4.6.2 (no changes)

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Thu, 16 Mar 2023 11:33:43 -0500

mongo-cxx-driver (3.7.0-1) experimental; urgency=medium

  * New upstream release
  * Bump dependency on libmongoc-dev
  * Update to Standards-Version 4.6.1 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 03 Oct 2022 16:14:30 -0400

mongo-cxx-driver (3.6.7-1) experimental; urgency=medium

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 05 May 2022 17:58:52 -0400

mongo-cxx-driver (3.6.6-1) experimental; urgency=medium

  * New upstream release
  * Drop Samantha Ritter as uploader
  * Update to Standards-Version 4.6.0 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 09 Oct 2021 06:34:44 -0400

mongo-cxx-driver (3.6.5-1) experimental; urgency=medium

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 04 Jun 2021 17:27:05 -0400
